summaryrefslogtreecommitdiffstats
path: root/include/shell.sh
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2006-11-27 04:25:34 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2006-11-27 04:25:34 +0000
commit97c8cb1b64a660538b7ef6cf5a9b98f904a8bccc (patch)
treefeba8f12ecf70a0ebc7f38cb26cdcb0c2b49b6ec /include/shell.sh
parentbfcaec7ec83ccd7ce75cb001ef899de22745aa05 (diff)
trap chmod errors in tar unpack on bsd - modes like 02755 fail
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@5656 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'include/shell.sh')
-rw-r--r--include/shell.sh15
1 files changed, 15 insertions, 0 deletions
diff --git a/include/shell.sh b/include/shell.sh
index 6ee0cf603..1e60692b9 100644
--- a/include/shell.sh
+++ b/include/shell.sh
@@ -13,3 +13,18 @@ isset() {
eval "var=\"\${$1}\""
[ -n "$var" ]
}
+
+trapret() {(
+ local retvals="$1"; shift
+ local cmd="$1"; shift
+ for retval in $(echo $retvals); do
+ local trap_$retval=1
+ done
+ "$cmd" "$@" || {
+ local retval="$?"
+ eval "trapped=\${trap_$retval}"
+ [ -n "$trapped" ] || {
+ return $retval
+ }
+ }
+)}